package javax.management;

import java.io.IOException;
import java.io.InvalidObjectException;
import java.io.ObjectInputStream;
import java.security.BasicPermission;

public class MBeanTrustPermission extends BasicPermission
{
    private static final long serialVersionUID = -2952178077029018140L;
    
    public MBeanTrustPermission(String s) {
        this(s, null);
    }
    
    public MBeanTrustPermission(String name, String actions) {
        super(name, actions);
        validate(name, actions);
    }
    
    private static void validate(String str, String str2) {
        if (str2 != null && str2.length() > 0) {
            throw new IllegalArgumentException("MBeanTrustPermission actions must be null: " + str2);
        }
        if (!str.equals("register") && !str.equals("*")) {
            throw new IllegalArgumentException("MBeanTrustPermission: Unknown target name [" + str + "]");
        }
        return;
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
        try {
            validate(super.getName(), super.getActions());
        }
        catch (IllegalArgumentException ex) {
            throw new InvalidObjectException(ex.getMessage());
        }
    }
}
